#include "status.h"
#include "webtcp.h"
#include "pio_drvr.h"

static char outdata[2048];

static int		ad_data[11];
static char 	 o[]={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
					   0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

static char init=FALSE;

void ad_store( void );

#pragma argsused
void user_init (int user_data) {
char i;

	if (init) return;

	for (i=0; i < 20; i++) {			// turn off all the drivers
		ClrIOPt((int)i);
	}

	init=TRUE;
	return;
}


void user_store( void ) {
int i;

	for (i = 0; i < 11; i++ )   {
		ad_data[i]=GetAD(i);
	}

	return;
}

#define ON "<img src=\"on.gif\" witdth=20 height=20 hspace=10>"
#define OFF "<img src=\"off.gif\" witdth=20 height=20 hspace=10>"

char huge *parse_user_value( int index, int *len, int *status ) {

//	printf("%d",index);
	switch (index) {
		case 0:		case 1:		case 2:		case 3:		// AD data
		case 4:		case 5:		case 6:		case 7:
		case 8:		case 9:		case 10:
//			printf("%d: %d\n",index, ad_data[index]);
			itoa( ad_data[index], outdata, 10);
			break;

	// output 'off' radio selected
		case 20:	case 21:	case 22:	case 23:	case 24:
		case 25:	case 26:	case 27:	case 28:	case 29:
		case 30:	case 31:	case 32:	case 33:	case 34:
		case 35:	case 36:	case 37:	case 38:	case 39:
			if (o[index-20] == 0)
				strcpy(outdata,"checked");
			else
				outdata[0]='\0';
			break;

	// output 'on' radion selected
		case 40:	case 41:	case 42:	case 43:	case 44:
		case 45:	case 46:	case 47:	case 48:	case 49:
		case 50:	case 51:	case 52:	case 53:	case 54:
		case 55:	case 56:	case 57:	case 58:	case 59:
			if (o[index-40] == 1)
				strcpy(outdata,"checked");
			else
				outdata[0]='\0';
			break;

	// inputs
		case 60:	case 61:	case 62:	case 63:	case 64:
		case 65:	case 66:	case 67:	case 68:	case 69:
		case 70:	case 71:	case 72:	case 73:	case 74:
		case 75:	case 76:	case 77:	case 78:	case 79:
		case 80:	case 81:	case 82:	case 83:	case 84:
		case 85:	case 86:	case 87:	case 88:	case 89:
		case 90:	case 91:

			if ( GetIOPt( (int) (index-60) ) )
				strcpy(outdata,ON);
			else
				strcpy(outdata,OFF);

			break;

		case 99:			// current local (server) time
			make_local_time( outdata );
			break;

		default:
			*len = 0;	*status = NOT_FOUND;
			return( NULL );
   }
	*len = strlen(outdata);	*status = OK;
	return( outdata );

}

// called when request for USER.SCR
// buffer contains the request string excluding the filename and the
// http request type.

int user_sht( char * buffer )
{
unsigned int port;           	// I/O port location
unsigned int value=0;
char *ptr;              		// parsing pointer

	strupr( buffer );   // make it upper case

//	printf("\nproc_mio %s\n",buffer);

	if( buffer != NULL ) {
		strcpy( outdata, buffer );
		ptr=strtok(outdata, "&");

		while( ptr ) {
//			printf("%s, ",ptr);
			if (*ptr == 'O') {
//				port=*(ptr+1)-0x30;
				port=atoi( (ptr+1) );
				value=(*(ptr+(port>9?4:3))-0x30==0) ? 0:1;
				o[port]=value;
				if (value)
					SetIOPt( (int)port );
				else
					ClrIOPt( (int)port );

//				printf("Driver %d %d %d\n", port, (int)value, (int)o[port]);
			}
			else
				;
			ptr=strtok( NULL,"&" );
		}
	}

	return(NO_CONTENT);     // good return code, browser shouldn't
							// change screens or give error
}

void user_close( void ) {

// insert exit code if required

	return;
}

